// Code generated by goctl. DO NOT EDIT.
package types

import (
	"fusenapi/utils/basic"
)

type GetProductListReq struct {
	Cid    int64  `form:"cid"`
	Size   uint32 `form:"size"`
	Page   uint32 `form:"page"`
	IsDemo uint32 `form:"is_demo" , options=0|1"`
}

type GetProductListRsp struct {
	Ob          Ob     `json:"ob"`
	TypeName    string `json:"typeName"`
	Description string `json:"description"`
}

type Ob struct {
	Items []Items `json:"items"`
	Links Links   `json:"_links"`
	Meta  Meta    `json:"_meta"`
}

type Meta struct {
	TotalCount  int32 `json:"totalCount"`
	PageCount   int32 `json:"pageCount"`
	CurrentPage int32 `json:"currentPage"`
	PerPage     int32 `json:"perPage"`
}

type Links struct {
	Self  HrefUrl `json:"self"`
	First HrefUrl `json:"first"`
	Last  HrefUrl `json:"last"`
	Next  HrefUrl `json:"next"`
}

type HrefUrl struct {
	Href string `json:"href"`
}

type Items struct {
	Id           int64   `json:"id"`
	Sn           string  `json:"sn"`
	Title        string  `json:"title"`
	Cover        string  `json:"cover"`
	Intro        string  `json:"intro"`
	CoverImg     string  `json:"cover_img"`
	IsEnv        int64   `json:"isEnv"`
	IsMicro      int64   `json:"isMicro"`
	SizeNum      uint32  `json:"sizeNum"`
	MiniPrice    float64 `json:"miniPrice"`
	CoverDefault string  `json:"coverDefault"`
}

type GetSuccessRecommandReq struct {
	Num  uint32 `form:"num"`
	Size uint32 `form:"size"`
	Sn   string `form:"sn"`
}

type GetSuccessRecommandRsp struct {
	Title        string `json:"title"`
	Cover        string `json:"cover"`
	CoverImg     string `json:"coverImg"`
	Sn           string `json:"sn"`
	Id           int64  `json:"id"`
	SkuId        int64  `json:"skuId"`
	CoverDefault string `json:"coverDefault"`
}

type GetSizeByProductRsp struct {
	Id       int64      `json:"id"`
	Name     string     `json:"name"`
	Children []Children `json:"children"`
}

type Children struct {
	Id           int64         `json:"id"`
	Name         string        `json:"name"`
	Cycle        int           `json:"cycle"`
	ChildrenList []ChildrenObj `json:"children"`
}

type ChildrenObj struct {
	Id        int64      `json:"id"`
	Name      string     `json:"name"`
	PriceList []PriceObj `json:"price_list"`
}

type PriceObj struct {
	Num   int     `json:"num"`
	Price float64 `json:"price"`
}

type Request struct {
}

type Response struct {
	Code    int         `json:"code"`
	Message string      `json:"msg"`
	Data    interface{} `json:"data"`
}

type ResponseJwt struct {
	Code         int         `json:"code"`
	Message      string      `json:"msg"`
	Data         interface{} `json:"data"`
	AccessSecret string      `json:"accessSecret"`
	AccessExpire int64       `json:"accessExpire"`
}

type Auth struct {
	AccessSecret string `json:"accessSecret"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

// Set 设置Response的Code和Message值
func (resp *Response) Set(Code int, Message string) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
	}
}

// Set 设置整个Response
func (resp *Response) SetWithData(Code int, Message string, Data interface{}) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
		Data:    Data,
	}
}

// SetStatus 设置默认StatusResponse(内部自定义) 默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatus(sr *basic.StatusResponse, data ...interface{}) *Response {
	newResp := &Response{
		Code: sr.Code,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}

// SetStatusWithMessage 设置默认StatusResponse(内部自定义) 非默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatusWithMessage(sr *basic.StatusResponse, msg string, data ...interface{}) *Response {
	newResp := &Response{
		Code:    sr.Code,
		Message: msg,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}
